# coding: utf-8

"""
    LUXSCI

    For a technical overview, see [LuxSci API Mechanics Guide](/rest-api/mechanics.html)  Return to [The API Guide](/rest-api.html)  # noqa: E501

    OpenAPI spec version: v2024.1.2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AccountIdDkimBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'domain': 'str',
        'selector': 'str',
        'bits': 'int'
    }

    attribute_map = {
        'domain': 'domain',
        'selector': 'selector',
        'bits': 'bits'
    }

    def __init__(self, domain=None, selector=None, bits=None):  # noqa: E501
        """AccountIdDkimBody - a model defined in Swagger"""  # noqa: E501
        self._domain = None
        self._selector = None
        self._bits = None
        self.discriminator = None
        self.domain = domain
        if selector is not None:
            self.selector = selector
        if bits is not None:
            self.bits = bits

    @property
    def domain(self):
        """Gets the domain of this AccountIdDkimBody.  # noqa: E501

        Required. Domain name that this DKIM definition should apply to. This is the “From” domain in email messages sent. A DKIM definition for this domain must not already exist in the account.  # noqa: E501

        :return: The domain of this AccountIdDkimBody.  # noqa: E501
        :rtype: str
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this AccountIdDkimBody.

        Required. Domain name that this DKIM definition should apply to. This is the “From” domain in email messages sent. A DKIM definition for this domain must not already exist in the account.  # noqa: E501

        :param domain: The domain of this AccountIdDkimBody.  # noqa: E501
        :type: str
        """
        if domain is None:
            raise ValueError("Invalid value for `domain`, must not be `None`")  # noqa: E501

        self._domain = domain

    @property
    def selector(self):
        """Gets the selector of this AccountIdDkimBody.  # noqa: E501

        Optional: default value “dkim”. Text tag to denote messages sent using this DKIM definition (e.g., “dkim”). This must contain only letters and numbers.  # noqa: E501

        :return: The selector of this AccountIdDkimBody.  # noqa: E501
        :rtype: str
        """
        return self._selector

    @selector.setter
    def selector(self, selector):
        """Sets the selector of this AccountIdDkimBody.

        Optional: default value “dkim”. Text tag to denote messages sent using this DKIM definition (e.g., “dkim”). This must contain only letters and numbers.  # noqa: E501

        :param selector: The selector of this AccountIdDkimBody.  # noqa: E501
        :type: str
        """

        self._selector = selector

    @property
    def bits(self):
        """Gets the bits of this AccountIdDkimBody.  # noqa: E501

        Optional: default value 2048. Valid values: 1024, 2048, 4096.  # noqa: E501

        :return: The bits of this AccountIdDkimBody.  # noqa: E501
        :rtype: int
        """
        return self._bits

    @bits.setter
    def bits(self, bits):
        """Sets the bits of this AccountIdDkimBody.

        Optional: default value 2048. Valid values: 1024, 2048, 4096.  # noqa: E501

        :param bits: The bits of this AccountIdDkimBody.  # noqa: E501
        :type: int
        """

        self._bits = bits

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AccountIdDkimBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountIdDkimBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
