# coding: utf-8

"""
    LUXSCI

    For a technical overview, see [LuxSci API Mechanics Guide](/rest-api/mechanics.html)  Return to [The API Guide](/rest-api.html)  # noqa: E501

    OpenAPI spec version: v2024.2.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from luxsci.api_client import ApiClient


class WebAidesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_update_web_aide_entries(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """add_update_web_aide_entries  # noqa: E501

        Add/update multiple entries of a WebAide all at once.  Address Book Imports: SecureLine data can be sent in this way as well (i.e. Escrow question and answer, PGP key, S/MIME key, etc.). SecureLine data is imported if and only if the “SecureLine Mode” field is present and not empty for an entry. Any entries that are updated and for which “SecureLine Mode” is left blank, will have their existing SecureLine settings left “as-is”.  Note: Each WebAide is limited to 25,000 entries by default. If your WebAide has this many entries (or more), then this AddUpdateWebAideEntries command will return an error (even if you are only intending to do updates). If you need larger WebAides, please contact support. Very large WebAides may require use of a dedicated server.  See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Add/Update Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_update_web_aide_entries(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param EntriesImportBody body:
        :param str cookie:
        :return: InlineResponse20031
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_update_web_aide_entries_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
        else:
            (data) = self.add_update_web_aide_entries_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
            return data

    def add_update_web_aide_entries_with_http_info(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """add_update_web_aide_entries  # noqa: E501

        Add/update multiple entries of a WebAide all at once.  Address Book Imports: SecureLine data can be sent in this way as well (i.e. Escrow question and answer, PGP key, S/MIME key, etc.). SecureLine data is imported if and only if the “SecureLine Mode” field is present and not empty for an entry. Any entries that are updated and for which “SecureLine Mode” is left blank, will have their existing SecureLine settings left “as-is”.  Note: Each WebAide is limited to 25,000 entries by default. If your WebAide has this many entries (or more), then this AddUpdateWebAideEntries command will return an error (even if you are only intending to do updates). If you need larger WebAides, please contact support. Very large WebAides may require use of a dedicated server.  See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Add/Update Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_update_web_aide_entries_with_http_info(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param EntriesImportBody body:
        :param str cookie:
        :return: InlineResponse20031
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'body', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_update_web_aide_entries" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `add_update_web_aide_entries`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `add_update_web_aide_entries`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `add_update_web_aide_entries`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}/entries/import', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20031',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_web_aide(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """delete_web_aide  # noqa: E501

        Delete a WebAide of type `webaide_type` whose unique ID is `webaide_id`. This WebAide must be owned by the user in question. See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Delete Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_web_aide(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str cookie:
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_web_aide_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_web_aide_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
            return data

    def delete_web_aide_with_http_info(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """delete_web_aide  # noqa: E501

        Delete a WebAide of type `webaide_type` whose unique ID is `webaide_id`. This WebAide must be owned by the user in question. See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Delete Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_web_aide_with_http_info(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str cookie:
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_web_aide" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `delete_web_aide`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `delete_web_aide`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `delete_web_aide`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse201',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_web_aide_entries(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """delete_web_aide_entries  # noqa: E501

        Delete multiple entries from a WebAide all at once. (Since we are not deleting an individual entity at a specific address, this is a POST instead of a DELETE method). See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Delete Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_web_aide_entries(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param EntriesDeleteBody body:
        :param str cookie:
        :return: InlineResponse20029
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_web_aide_entries_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_web_aide_entries_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
            return data

    def delete_web_aide_entries_with_http_info(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """delete_web_aide_entries  # noqa: E501

        Delete multiple entries from a WebAide all at once. (Since we are not deleting an individual entity at a specific address, this is a POST instead of a DELETE method). See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Delete Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_web_aide_entries_with_http_info(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param EntriesDeleteBody body:
        :param str cookie:
        :return: InlineResponse20029
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'body', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_web_aide_entries" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `delete_web_aide_entries`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `delete_web_aide_entries`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `delete_web_aide_entries`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}/entries/delete', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20029',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_web_aide_entry(self, username, webaide_type, webaide_id, entry_id, **kwargs):  # noqa: E501
        """delete_web_aide_entry  # noqa: E501

        Delete an existing WebAide Entry. See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Delete Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_web_aide_entry(username, webaide_type, webaide_id, entry_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str entry_id: (required)
        :param str cookie:
        :return: InlineResponse20026
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, **kwargs)  # noqa: E501
            return data

    def delete_web_aide_entry_with_http_info(self, username, webaide_type, webaide_id, entry_id, **kwargs):  # noqa: E501
        """delete_web_aide_entry  # noqa: E501

        Delete an existing WebAide Entry. See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Delete Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str entry_id: (required)
        :param str cookie:
        :return: InlineResponse20026
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'entry_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_web_aide_entry" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `delete_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `delete_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `delete_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'entry_id' is set
        if ('entry_id' not in params or
                params['entry_id'] is None):
            raise ValueError("Missing the required parameter `entry_id` when calling `delete_web_aide_entry`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501
        if 'entry_id' in params:
            path_params['entry_id'] = params['entry_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}/{entry_id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20026',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_calendar_entries_date_range(self, username, webaide_id, before, _from, **kwargs):  # noqa: E501
        """get_calendar_entries_date_range  # noqa: E501

        Gets a list of entries in a specified Calendar WebAide that fall within a specified range of dates. For recurring entries, the entry will be returned if any of its instances fall within the specified date range. The date range is taken to be dates in GMT. See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to WebAide Calendars; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_calendar_entries_date_range(username, webaide_id, before, _from, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_id: (required)
        :param str before: DATE: “YYYY-MM-DD” in GMT (where 00:00:00 GMT is implied) Required. Entries that contain events before this date. (required)
        :param str _from: DATE: “YYYY-MM-DD” in GMT (where 00:00:00 GMT is implied)<br><br>Required. Entries that contain events on or after this date. (required)
        :param str entries: Comma-delimited list of entry Unique IDs. e.g. “10786,77892,23”<br><br>Optional. If included, the search is restricted to only entries in this list.<br><br>Note, if you want to use a very long list of entries, you might want to use several requests so that you do not exceed the maximum URL query string size of 8190 bytes.
        :param str cookie:
        :return: InlineResponse20028
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_calendar_entries_date_range_with_http_info(username, webaide_id, before, _from, **kwargs)  # noqa: E501
        else:
            (data) = self.get_calendar_entries_date_range_with_http_info(username, webaide_id, before, _from, **kwargs)  # noqa: E501
            return data

    def get_calendar_entries_date_range_with_http_info(self, username, webaide_id, before, _from, **kwargs):  # noqa: E501
        """get_calendar_entries_date_range  # noqa: E501

        Gets a list of entries in a specified Calendar WebAide that fall within a specified range of dates. For recurring entries, the entry will be returned if any of its instances fall within the specified date range. The date range is taken to be dates in GMT. See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to WebAide Calendars; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_calendar_entries_date_range_with_http_info(username, webaide_id, before, _from, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_id: (required)
        :param str before: DATE: “YYYY-MM-DD” in GMT (where 00:00:00 GMT is implied) Required. Entries that contain events before this date. (required)
        :param str _from: DATE: “YYYY-MM-DD” in GMT (where 00:00:00 GMT is implied)<br><br>Required. Entries that contain events on or after this date. (required)
        :param str entries: Comma-delimited list of entry Unique IDs. e.g. “10786,77892,23”<br><br>Optional. If included, the search is restricted to only entries in this list.<br><br>Note, if you want to use a very long list of entries, you might want to use several requests so that you do not exceed the maximum URL query string size of 8190 bytes.
        :param str cookie:
        :return: InlineResponse20028
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_id', 'before', '_from', 'entries', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_calendar_entries_date_range" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_calendar_entries_date_range`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `get_calendar_entries_date_range`")  # noqa: E501
        # verify the required parameter 'before' is set
        if ('before' not in params or
                params['before'] is None):
            raise ValueError("Missing the required parameter `before` when calling `get_calendar_entries_date_range`")  # noqa: E501
        # verify the required parameter '_from' is set
        if ('_from' not in params or
                params['_from'] is None):
            raise ValueError("Missing the required parameter `_from` when calling `get_calendar_entries_date_range`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501

        query_params = []
        if 'before' in params:
            query_params.append(('before', params['before']))  # noqa: E501
        if 'entries' in params:
            query_params.append(('entries', params['entries']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/calendar/{webaide_id}/entries/date_range', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20028',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_web_aide(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """get_web_aide  # noqa: E501

        This call is like `getWebAides`, except that the call is simplified and targeted at a specific, single WebAide. See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aide(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str changes: Optional. DateTime in GMT in the format: YYYY-MM-DD HH:MM:SS. If this is provided, a sub call to “GetWebAideChanges” will be made for each returned WebAide, giving you summary counts of numbers of entries and adds/updates/deletes since the specified date.<br><br>Specify an old date (e.g. “2000-01-01”) if all you care about is the total number of entries.<br><br>Use of “changes” is the recommended way to get the number of entries in one or more WebAides in an efficient manner.
        :param str cookie:
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_web_aide_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_web_aide_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
            return data

    def get_web_aide_with_http_info(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """get_web_aide  # noqa: E501

        This call is like `getWebAides`, except that the call is simplified and targeted at a specific, single WebAide. See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aide_with_http_info(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str changes: Optional. DateTime in GMT in the format: YYYY-MM-DD HH:MM:SS. If this is provided, a sub call to “GetWebAideChanges” will be made for each returned WebAide, giving you summary counts of numbers of entries and adds/updates/deletes since the specified date.<br><br>Specify an old date (e.g. “2000-01-01”) if all you care about is the total number of entries.<br><br>Use of “changes” is the recommended way to get the number of entries in one or more WebAides in an efficient manner.
        :param str cookie:
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'changes', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_web_aide" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_web_aide`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `get_web_aide`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `get_web_aide`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501

        query_params = []
        if 'changes' in params:
            query_params.append(('changes', params['changes']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20022',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_web_aide_changes(self, username, webaide_type, webaide_id, modified, **kwargs):  # noqa: E501
        """get_web_aide_changes  # noqa: E501

        Return all WebAide entries added, changed, or deleted since a particular time. See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aide_changes(username, webaide_type, webaide_id, modified, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str modified: Timestamp “YYYYMMDDHHMMSS” in GMT or “YYYY-MM-DD HH:MM:SS” in GMT<br><br>Return all WebAide entries added, changed, or deleted since this timestamp. If you specify “0” here, it will return a list of all entries that exist now and all that have been deleted. (required)
        :param str cookie:
        :return: InlineResponse20030
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_web_aide_changes_with_http_info(username, webaide_type, webaide_id, modified, **kwargs)  # noqa: E501
        else:
            (data) = self.get_web_aide_changes_with_http_info(username, webaide_type, webaide_id, modified, **kwargs)  # noqa: E501
            return data

    def get_web_aide_changes_with_http_info(self, username, webaide_type, webaide_id, modified, **kwargs):  # noqa: E501
        """get_web_aide_changes  # noqa: E501

        Return all WebAide entries added, changed, or deleted since a particular time. See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aide_changes_with_http_info(username, webaide_type, webaide_id, modified, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str modified: Timestamp “YYYYMMDDHHMMSS” in GMT or “YYYY-MM-DD HH:MM:SS” in GMT<br><br>Return all WebAide entries added, changed, or deleted since this timestamp. If you specify “0” here, it will return a list of all entries that exist now and all that have been deleted. (required)
        :param str cookie:
        :return: InlineResponse20030
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'modified', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_web_aide_changes" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_web_aide_changes`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `get_web_aide_changes`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `get_web_aide_changes`")  # noqa: E501
        # verify the required parameter 'modified' is set
        if ('modified' not in params or
                params['modified'] is None):
            raise ValueError("Missing the required parameter `modified` when calling `get_web_aide_changes`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501

        query_params = []
        if 'modified' in params:
            query_params.append(('modified', params['modified']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}/entries/changes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20030',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_web_aide_entries(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """get_web_aide_entries  # noqa: E501

        Retrieve the detailed contents of all WebAide entries matching a query. See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aide_entries(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param list[str] entries: Optional. Comma-delimited list of entry Unique IDs. e.g. “10786,77892,23”.  If included, the search is restricted to only entries in this list.  Note, if you want to use a very long list of entries, you might want to use several requests so that you do not exceed the maximum URL query string size of 8190 bytes.
        :param int limit: Optional. Integer 1 to 500. How many entries to return (maximum). Default is 500.
        :param int resume: Integer:1 or 0. If 0 (the default), begin a new search. If 1, continue the previous search. When returning successive “pages” or entries, use resume for faster and more consistent results.
        :param int secureline: Integer 1 or 0 If specified as ‘1’, SecureLine-specific Address Book fields are included in the export. I.e., this includes the SecureLine Escrow Question/Answer pair and/or PGP and S/MIME public keys.
        :param int showcomplete: Integer 1 or 0 If specified as ‘1’, get completed tasks for ‘Tasks’ WebAides. By default, only uncompleted tasks are returned.
        :param str sort: Optional method by which the returned entries should be sorted.
        :param int start: Optional. The default is 0. Index in the list of all entries from which to start the result set. Use this to return successive “pages” of entries.
        :param str timezone: Time zone code. The time zone to use for Calendar/Task dates and times. The user’s default time zone is used if no time zone is specified.
        :param str cookie:
        :return: InlineResponse20027
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_web_aide_entries_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_web_aide_entries_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
            return data

    def get_web_aide_entries_with_http_info(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """get_web_aide_entries  # noqa: E501

        Retrieve the detailed contents of all WebAide entries matching a query. See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aide_entries_with_http_info(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param list[str] entries: Optional. Comma-delimited list of entry Unique IDs. e.g. “10786,77892,23”.  If included, the search is restricted to only entries in this list.  Note, if you want to use a very long list of entries, you might want to use several requests so that you do not exceed the maximum URL query string size of 8190 bytes.
        :param int limit: Optional. Integer 1 to 500. How many entries to return (maximum). Default is 500.
        :param int resume: Integer:1 or 0. If 0 (the default), begin a new search. If 1, continue the previous search. When returning successive “pages” or entries, use resume for faster and more consistent results.
        :param int secureline: Integer 1 or 0 If specified as ‘1’, SecureLine-specific Address Book fields are included in the export. I.e., this includes the SecureLine Escrow Question/Answer pair and/or PGP and S/MIME public keys.
        :param int showcomplete: Integer 1 or 0 If specified as ‘1’, get completed tasks for ‘Tasks’ WebAides. By default, only uncompleted tasks are returned.
        :param str sort: Optional method by which the returned entries should be sorted.
        :param int start: Optional. The default is 0. Index in the list of all entries from which to start the result set. Use this to return successive “pages” of entries.
        :param str timezone: Time zone code. The time zone to use for Calendar/Task dates and times. The user’s default time zone is used if no time zone is specified.
        :param str cookie:
        :return: InlineResponse20027
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'entries', 'limit', 'resume', 'secureline', 'showcomplete', 'sort', 'start', 'timezone', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_web_aide_entries" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_web_aide_entries`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `get_web_aide_entries`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `get_web_aide_entries`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501

        query_params = []
        if 'entries' in params:
            query_params.append(('entries', params['entries']))  # noqa: E501
            collection_formats['entries'] = 'csv'  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'resume' in params:
            query_params.append(('resume', params['resume']))  # noqa: E501
        if 'secureline' in params:
            query_params.append(('secureline', params['secureline']))  # noqa: E501
        if 'showcomplete' in params:
            query_params.append(('showcomplete', params['showcomplete']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'start' in params:
            query_params.append(('start', params['start']))  # noqa: E501
        if 'timezone' in params:
            query_params.append(('timezone', params['timezone']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}/entries', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20027',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_web_aide_entry(self, username, webaide_type, webaide_id, entry_id, **kwargs):  # noqa: E501
        """get_web_aide_entry  # noqa: E501

        Retrieve the detailed contents of a specific WebAide entry. See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aide_entry(username, webaide_type, webaide_id, entry_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str entry_id: (required)
        :param str cookie:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, **kwargs)  # noqa: E501
            return data

    def get_web_aide_entry_with_http_info(self, username, webaide_type, webaide_id, entry_id, **kwargs):  # noqa: E501
        """get_web_aide_entry  # noqa: E501

        Retrieve the detailed contents of a specific WebAide entry. See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str entry_id: (required)
        :param str cookie:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'entry_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_web_aide_entry" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `get_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `get_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'entry_id' is set
        if ('entry_id' not in params or
                params['entry_id'] is None):
            raise ValueError("Missing the required parameter `entry_id` when calling `get_web_aide_entry`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501
        if 'entry_id' in params:
            path_params['entry_id'] = params['entry_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}/{entry_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_web_aides(self, username, webaide_type, **kwargs):  # noqa: E501
        """get_web_aides  # noqa: E501

        Return a list of all WebAides accessible to the specified user, that are also of the indicated type. You can use the query string to add filters to narrow down the results. See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aides(username, webaide_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str subscribed: Filter by WebAide subscription status<ul><li>all - select all</li><li>subscribed - return those subscribed</li><li>unsubscribed - return those not subscribed</li><li>tosync - return those tagged for synchronization with MobileSync.</li>
        :param list[str] ids: List of the numerical WebAide IDs eligible to be returned.
        :param list[str] permissions: Values can include those in the webaide_permission list. Select only WebAides where the user has all of the indicated permissions
        :param str modified: DateTime in GMT in the format: YYYY-MM-DD HH:MM:SS. Return all WebAides that have had any entry created, deleted, or modified on or after this date and time. Values can include those in the webaide_permission list.
        :param str changes: Optional. DateTime in GMT in the format: YYYY-MM-DD HH:MM:SS. If this is provided, a sub call to “GetWebAideChanges” will be made for each returned WebAide, giving you summary counts of numbers of entries and adds/ updates/deletes since the specified date.<br><br>Specify an old date (e.g. “2000-01-01”) if all you care about is the total number of entries.<br><br>Use of “changes” is the recommended way to get the number of entries in one or more WebAides in an efficient manner.
        :param str cookie:
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_web_aides_with_http_info(username, webaide_type, **kwargs)  # noqa: E501
        else:
            (data) = self.get_web_aides_with_http_info(username, webaide_type, **kwargs)  # noqa: E501
            return data

    def get_web_aides_with_http_info(self, username, webaide_type, **kwargs):  # noqa: E501
        """get_web_aides  # noqa: E501

        Return a list of all WebAides accessible to the specified user, that are also of the indicated type. You can use the query string to add filters to narrow down the results. See also [WebAide definitions](/rest-api/webaides.html). {{ACL: Access to that specific type of WebAides; Read Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_web_aides_with_http_info(username, webaide_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str subscribed: Filter by WebAide subscription status<ul><li>all - select all</li><li>subscribed - return those subscribed</li><li>unsubscribed - return those not subscribed</li><li>tosync - return those tagged for synchronization with MobileSync.</li>
        :param list[str] ids: List of the numerical WebAide IDs eligible to be returned.
        :param list[str] permissions: Values can include those in the webaide_permission list. Select only WebAides where the user has all of the indicated permissions
        :param str modified: DateTime in GMT in the format: YYYY-MM-DD HH:MM:SS. Return all WebAides that have had any entry created, deleted, or modified on or after this date and time. Values can include those in the webaide_permission list.
        :param str changes: Optional. DateTime in GMT in the format: YYYY-MM-DD HH:MM:SS. If this is provided, a sub call to “GetWebAideChanges” will be made for each returned WebAide, giving you summary counts of numbers of entries and adds/ updates/deletes since the specified date.<br><br>Specify an old date (e.g. “2000-01-01”) if all you care about is the total number of entries.<br><br>Use of “changes” is the recommended way to get the number of entries in one or more WebAides in an efficient manner.
        :param str cookie:
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'subscribed', 'ids', 'permissions', 'modified', 'changes', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_web_aides" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_web_aides`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `get_web_aides`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501

        query_params = []
        if 'subscribed' in params:
            query_params.append(('subscribed', params['subscribed']))  # noqa: E501
        if 'ids' in params:
            query_params.append(('ids', params['ids']))  # noqa: E501
            collection_formats['ids'] = 'csv'  # noqa: E501
        if 'permissions' in params:
            query_params.append(('permissions', params['permissions']))  # noqa: E501
            collection_formats['permissions'] = 'csv'  # noqa: E501
        if 'modified' in params:
            query_params.append(('modified', params['modified']))  # noqa: E501
        if 'changes' in params:
            query_params.append(('changes', params['changes']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20022',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def new_web_aide(self, username, webaide_type, **kwargs):  # noqa: E501
        """new_web_aide  # noqa: E501

        Create a new WebAide of type webaide_type. E.g. creation of a new “Address Book”.   Note: Each user is limited to 500 WebAides of each type. Trying to create more will result in an error being returned.  See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Add/Update Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.new_web_aide(username, webaide_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param WebaidesWebaideTypeBody body:
        :param str cookie:
        :return: InlineResponse20023
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.new_web_aide_with_http_info(username, webaide_type, **kwargs)  # noqa: E501
        else:
            (data) = self.new_web_aide_with_http_info(username, webaide_type, **kwargs)  # noqa: E501
            return data

    def new_web_aide_with_http_info(self, username, webaide_type, **kwargs):  # noqa: E501
        """new_web_aide  # noqa: E501

        Create a new WebAide of type webaide_type. E.g. creation of a new “Address Book”.   Note: Each user is limited to 500 WebAides of each type. Trying to create more will result in an error being returned.  See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Add/Update Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.new_web_aide_with_http_info(username, webaide_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param WebaidesWebaideTypeBody body:
        :param str cookie:
        :return: InlineResponse20023
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'body', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method new_web_aide" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `new_web_aide`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `new_web_aide`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20023',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def new_web_aide_entry(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """new_web_aide_entry  # noqa: E501

        Create a new WebAide Entry. Note that invalid fields may simply be ignored, rather than generate an actual error. E.g. an invalid “E-mail Address” field will simply result in that field being omitted in the new entry. We recommend that you validate your own data and not rely on request errors to do the validation for you.  Note: Each WebAide is limited to 25,000 entries by default. If your WebAide has this many entries (or more), then this NewWebAideEntry command will return an error. If you need larger WebAides, please contact support. Very large WebAides may require the use of a dedicated server.  See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Add/Change Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.new_web_aide_entry(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param WebaideTypeWebaideIdBody body:
        :param str cookie:
        :return: InlineResponse20024
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.new_web_aide_entry_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
        else:
            (data) = self.new_web_aide_entry_with_http_info(username, webaide_type, webaide_id, **kwargs)  # noqa: E501
            return data

    def new_web_aide_entry_with_http_info(self, username, webaide_type, webaide_id, **kwargs):  # noqa: E501
        """new_web_aide_entry  # noqa: E501

        Create a new WebAide Entry. Note that invalid fields may simply be ignored, rather than generate an actual error. E.g. an invalid “E-mail Address” field will simply result in that field being omitted in the new entry. We recommend that you validate your own data and not rely on request errors to do the validation for you.  Note: Each WebAide is limited to 25,000 entries by default. If your WebAide has this many entries (or more), then this NewWebAideEntry command will return an error. If you need larger WebAides, please contact support. Very large WebAides may require the use of a dedicated server.  See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Add/Change Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.new_web_aide_entry_with_http_info(username, webaide_type, webaide_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param WebaideTypeWebaideIdBody body:
        :param str cookie:
        :return: InlineResponse20024
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'body', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method new_web_aide_entry" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `new_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `new_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `new_web_aide_entry`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20024',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_web_aide_entry(self, username, webaide_type, webaide_id, entry_id, **kwargs):  # noqa: E501
        """update_web_aide_entry  # noqa: E501

        Update an existing WebAide Entry. This function will replace the data in all entry fields with the new data supplied. It is recommended that you retrieve the complete entry, alter it, and then update it – so that you update does not delete data from an entry simply because you did not include those fields in your update.  File attachments on entries are unaffected by this command.   See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Add/Change Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_web_aide_entry(username, webaide_type, webaide_id, entry_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str entry_id: (required)
        :param WebaideIdEntryIdBody body:
        :param str cookie:
        :return: InlineResponse20025
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, **kwargs)  # noqa: E501
        else:
            (data) = self.update_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, **kwargs)  # noqa: E501
            return data

    def update_web_aide_entry_with_http_info(self, username, webaide_type, webaide_id, entry_id, **kwargs):  # noqa: E501
        """update_web_aide_entry  # noqa: E501

        Update an existing WebAide Entry. This function will replace the data in all entry fields with the new data supplied. It is recommended that you retrieve the complete entry, alter it, and then update it – so that you update does not delete data from an entry simply because you did not include those fields in your update.  File attachments on entries are unaffected by this command.   See also [WebAide definitions](/rest-api/webaides.html).  {{ACL: Access to that specific type of WebAides; Add/Change Accessible WebAides and Entries }}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_web_aide_entry_with_http_info(username, webaide_type, webaide_id, entry_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str webaide_type: (required)
        :param str webaide_id: (required)
        :param str entry_id: (required)
        :param WebaideIdEntryIdBody body:
        :param str cookie:
        :return: InlineResponse20025
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'webaide_type', 'webaide_id', 'entry_id', 'body', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_web_aide_entry" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `update_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'webaide_type' is set
        if ('webaide_type' not in params or
                params['webaide_type'] is None):
            raise ValueError("Missing the required parameter `webaide_type` when calling `update_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'webaide_id' is set
        if ('webaide_id' not in params or
                params['webaide_id'] is None):
            raise ValueError("Missing the required parameter `webaide_id` when calling `update_web_aide_entry`")  # noqa: E501
        # verify the required parameter 'entry_id' is set
        if ('entry_id' not in params or
                params['entry_id'] is None):
            raise ValueError("Missing the required parameter `entry_id` when calling `update_web_aide_entry`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'webaide_type' in params:
            path_params['webaide_type'] = params['webaide_type']  # noqa: E501
        if 'webaide_id' in params:
            path_params['webaide_id'] = params['webaide_id']  # noqa: E501
        if 'entry_id' in params:
            path_params['entry_id'] = params['entry_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/webaides/{webaide_type}/{webaide_id}/{entry_id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20025',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
